﻿EnableExplicit

XIncludeFile "cairo180.pbi"

Enumeration
  #window
  #canvas
  #timer
  #fullscreen
  #font
EndEnumeration

#title = "Hexagon"
#version = 1.005
#menu_button_size = 50
#menu_button_margin = 5
#button_radius = 8.0

Structure cube
  x.f
  y.f
  s.f
  sc.f
  st.i
  matrix.i
  examine.i
  active.i
  group.i[6]
EndStructure

Structure menu
  func.i
  param.i
  image.i
  window.i
EndStructure

Declare init()
Declare main()
Declare close()

Declare event_reset(first.i)
Declare event_update(export.i)
Declare event_size()
Declare event_scroll(event)
Declare event_move(event.i,px.i,py.i,key.i)
Declare event_click(event.i,px.i,py.i)
Declare event_active(event.i,px.f,py.f)
Declare cube(x.f,y.f)
Declare draw_hexagon(x.f,y.f,s.f,su,*this.cube)
Declare pos(x.f,y.f,rad.f)
Declare scroll(scrole.f,x.f,y.f)
Declare item_hexagon(param.i,event.i)
Declare item_new(param.i,event.i)
Declare item_open(param.i,event.i)
Declare item_save(param.i,event.i)

Declare item_right(param.i,event.i)
Declare item_left(param.i,event.i)
Declare item_up(param.i,event.i)
Declare item_down(param.i,event.i)

Declare item_preview(param.i,event.i)

Declare item_scroll_in(param.i,event.i)
Declare item_scroll_out(param.i,event.i)
Declare event_menu(event.i,px.i,py.i)

Declare item_fullscreen(param.i,event.i)

Declare item_group(group.i,event.i)

Global cube_s.f = 50
Global cube_h.f = Round(Sin(Radian(30))*cube_s,#PB_Round_Nearest)
Global cube_r.f = Round(Cos(Radian(30))*cube_s,#PB_Round_Nearest)
Global cube_b.f = cube_s+2*cube_h
Global cube_a.f = 2*cube_r
Global window_style.i
Global fullscreen.i = #False

Define i.i

Global NewList item.menu()

AddElement(item())
item()\func = @item_hexagon()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\hexagon.png");

AddElement(item())
item()\func = @item_new()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\new.png");

AddElement(item())
item()\func = @item_open()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\open.png");

AddElement(item())
item()\func = @item_save()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\save.png");

 AddElement(item())
  item()\func = @item_group()
  item()\param = 0
  item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\select.png");
  
For i = 1 To 10
  AddElement(item())
  item()\func = @item_group()
  item()\param = i
  item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\group.png");
Next

AddElement(item())
item()\func = @item_left()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\left.png");

AddElement(item())
item()\func = @item_right()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\right.png");

AddElement(item())
item()\func = @item_up()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\up.png");

AddElement(item())
item()\func = @item_down()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\down.png");

AddElement(item())
item()\func = @item_scroll_in()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\scroll_in.png");

AddElement(item())
item()\func = @item_scroll_out()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\scroll_out.png");

AddElement(item())
item()\func = @item_preview()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\preview.png");

AddElement(item())
item()\func = @item_fullscreen()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\fullscreen.png");

Global NewList cubes.cube()
Global preview
Global scaling.f
Global posx.f
Global posy.f

Global window_width = 800
Global window_height = 600

Global move_vertical.f = 0
Global move_horizontal.f = 0
Global move = #False
Global move_x.f
Global move_y.f
Global menu_show = #True
Global menu_opacity.f = 1

Global current_group

Global su_draw = cairo_image_surface_create(0,window_width,window_height)

Global Dim group.f(11,4)

group(1,0) = 1
group(2,1) = 1
group(3,2) = 1
group(4,0) = 1
group(4,1) = 1
group(5,1) = 1
group(5,2) = 1
group(6,0) = 1
group(6,2) = 1

group(7,0) = 1
group(7,1) = 1
group(7,2) = 1

group(8,0) = 0.5
group(8,1) = 0.5
group(8,2) = 0.5

For i = 0 To ArraySize(group())-1
    group(i,3) = 1
Next

;;;;; PLUGINS INIT

;;;;; PLUGIN BASS INIT
Enumeration
  #basslib
EndEnumeration

Structure spectrum
  group.i
  color.i
  value.f
  mul.f
  add.f
  start.i
  len.i
  mulall.i
  dyn.i
  active.i
  
  gadget_active.i
  gadget_value.i
  gadget_mul.i
  gadget_add.i
  gadget_start.i
  gadget_len.i
  gadget_mulall.i
  gadget_dyn.i
EndStructure

Structure template
  name.s
  Array mixer.spectrum(10,4)
EndStructure

Prototype BASS_StreamCreateFile(mem.i, *file, offset.q, length.q, flags.l)
Prototype BASS_ChannelSetAttribute(handle.l,attribue.l,volume.f)
Prototype BASS_ChannelSetPosition(handle.l,pos.q,mode.l)
Prototype.d BASS_ChannelBytes2Seconds(handle.l,pos.q)
Prototype BASS_ChannelSeconds2Bytes(handle.l,pos.d)

Declare item_plugin_bass(param.i,event.i)
Declare.f avg(s.f,l.f,max.f)
Declare group_save()
Declare group_reload()

Global Dim group_cache.f(ArraySize(group()),ArraySize(group(),2))

Global BASS_StreamCreateFile.BASS_StreamCreateFile
Global BASS_ChannelSetAttribute.BASS_ChannelSetAttribute
Global BASS_ChannelSetPosition.BASS_ChannelSetPosition
Global BASS_ChannelBytes2Seconds.BASS_ChannelBytes2Seconds
Global BASS_ChannelSeconds2Bytes.BASS_ChannelSeconds2Bytes

Global *stream = 0
Global *byte_buffer = AllocateMemory(2048)
Global *visual_buffer = AllocateMemory(2048)
Global plugin_bass_window.i
Global gadget_mixer_template
Define a.i,b.i
Global gadget_bass

Global Dim mixer.spectrum(10,4)

For a = 1 To ArraySize(mixer())-1
  mixer(a,0)\value = 1
  mixer(a,0)\active = #True
  For b = 1 To 3
    mixer(a,b)\value = 1
    mixer(a,b)\mul = a*40
    mixer(a,b)\start = a
    mixer(a,b)\len = 1
   mixer(a,b)\dyn = #True
    mixer(a,b)\mulall = #True
    mixer(a,b)\active = Random(1,0)
    Next
  Next
  
  mixer(0,0)\value = 1
  mixer(0,0)\active = #True
    For b = 1 To 3
  mixer(0,b)\value = 1
  mixer(0,b)\mul = 10
  mixer(0,b)\start = 0
  mixer(0,b)\len = 10
  mixer(0,b)\dyn = #True
 mixer(0,b)\active = Random(1,0)
  Next

Global NewList templates.template()

AddElement(templates())
templates()\name = "Clear"
  
AddElement(templates())
templates()\name = "Clear (Value: Default)"

For a = 0 To ArraySize(templates()\mixer())-1
  For b = 0 To ArraySize(templates()\mixer(),2)-1
      templates()\mixer(a,b)\value = -1
    Next
  Next
  
AddElement(templates())
templates()\name = "FX Shader"

For a = 1 To ArraySize(templates()\mixer())-1
  templates()\mixer(a,0)\value = 1
  templates()\mixer(a,0)\active = #True
  For b = 1 To 3
    templates()\mixer(a,b)\value = 1
    templates()\mixer(a,b)\mul = a*40
    templates()\mixer(a,b)\start = a
    templates()\mixer(a,b)\len = 1
    templates()\mixer(a,b)\dyn = #True
    templates()\mixer(a,b)\mulall = #True
    templates()\mixer(a,b)\active = Random(1,0)
    Next
  Next
  
  templates()\mixer(0,0)\value = 1
  templates()\mixer(0,0)\active = #True
    For b = 1 To 3
  templates()\mixer(0,b)\value = 1
  templates()\mixer(0,b)\mul = 10
  templates()\mixer(0,b)\start = 0
  templates()\mixer(0,b)\len = 10
  templates()\mixer(0,b)\dyn = #True
  templates()\mixer(0,b)\active = Random(1,0)
  Next
  
Procedure group_save()
  Define a.i,b.i
  
   For a = 0 To ArraySize(group())
        For b = 0 To ArraySize(group(),2)
          group_cache(a,b) = group(a,b)
        Next
      Next
EndProcedure

Procedure group_reload()
  Define a.i,b.i
  
   For a = 0 To ArraySize(group())
        For b = 0 To ArraySize(group(),2)
          group(a,b) = group_cache(a,b)
        Next
      Next
EndProcedure

Procedure item_plugin_bass(param.i,event.i)
  If IsLibrary(#basslib)
    Define  Pattern$ = "MP3 Datei (*.mp3)"
Define Pattern = 0   
  Define File$ = OpenFileRequester("Bitte MP3 Datei auswählen", "", Pattern$, Pattern)
  If File$
    
    If *stream <> 0
      CallFunction(#basslib,"BASS_ChannelStop",*stream)
    EndIf
    
    *stream = BASS_StreamCreateFile(0,@File$,0,0,0)

     If *stream <> 0
       CallFunction(#basslib,"BASS_ChannelPlay",*stream,0)
       group_save()
       preview = #True
     EndIf   
     
     EndIf
  EndIf
EndProcedure

Procedure.f avg(s.f,l.f,max.f)
  Define i.i
  Define avg.f = 0
  Define avgi.f = 0

Define start.i = Int(512/max*s)*4
Define stop.i = (start + Int(512/max*l)*4)-4

  For i = start To stop Step 4
    avg + PeekF(*visual_buffer+i)
    avgi +1
  Next
  avg = avg/avgi
  
  ProcedureReturn avg
EndProcedure 

;;;;; PLUGIN BASS

;;; PLUGIN RECORD
Declare item_plugin_record(param.i,event.i)

AddElement(item())
item()\func = @item_plugin_record()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\plugin_record.png");

Procedure item_plugin_record(param.i,event.i)
  If event = #PB_EventType_MiddleButtonDown
    Debug 1
  Else
     Define Pattern$ = "PNG Datei (*.png)"
 Define Pattern = 0   
  Define File$ = SaveFileRequester("Bitte PNG Datei zum Speichern auswählen", "", Pattern$, Pattern)
  If File$
    Define filename.s = File$
    
    If Not Right(File$,Len(".png")) = ".png"
      filename + ".png"
    EndIf
    
    event_update(#True)
    
    cairo_surface_write_to_png (su_draw,filename);
    
    EndIf
    EndIf
  EndProcedure
  ;;; PLUGIN RECORD

;;;;PLUGIN ROTATE

;;;;; PLUGIN ROTATE INIT
Declare item_plugin_rotate(param.i,event.i)

Global rotate.f = 0
Global rotate_move.f = 0
Global rotate_scaling.f = 0
Global rotate_start.f = 0.2
Global rotate_speed.f = ((#PI*2)/360)
Global plugin_rotate_window
Global gadget_rotate_start
Global gadget_rotate_speed
Global gadget_rotate

Procedure item_plugin_rotate(param.i,event.i)

  If rotate_move > 0
      rotate_move = -((#PI*2)/360)
      Else
         rotate = 0
         rotate_move = rotate_speed
    EndIf

  preview = #True
EndProcedure
;;;;; PLUGIN ROTATE

;;;;; PLUGIN RANDOM INIT
Global loops.i = 100
Global max_cubes.i = 100
Global plugin_random_window
Global gadget_loops
Global gadget_max_cubes
Global gadget_random

Declare item_plugin_random(param.i,event.i)

Procedure item_plugin_random(param.i,event.i)
  Define px.f,py.f
      Define i.i
  If Not event = #PB_EventType_LeftDoubleClick
    ForEach cubes()
      For i = 0 To 5
        cubes()\group[i] = Random(9)
      Next
      Next
      ProcedureReturn
     EndIf
  
  event_reset(#True)

  For i = 0 To loops-1
    
    If i >= ListSize(cubes())-1
      FirstElement(cubes())
      Else
        SelectElement(cubes(),i)
        EndIf
    px = cubes()\x
    py = cubes()\y

    If Random(10) > Random(10) : cube(px+cube_r*2,py) : EndIf
	If Random(10) > Random(10) : cube(px-cube_r*2,py) : EndIf

	If Random(10) > Random(10) : cube(px+cube_r,py-cube_s-cube_h) : EndIf
	If Random(10) > Random(10) : cube(px-cube_r,py-cube_s-cube_h) : EndIf

	If Random(10) > Random(10) : cube(px+cube_r,py+cube_s+cube_h) : EndIf
	If Random(10) > Random(10) : cube(px-cube_r,py+cube_s+cube_h)    : EndIf 
	
	If ListSize(cubes()) >= max_cubes
	  Break
	 EndIf
Next

ForEach cubes()
  cubes()\matrix = Random(8)
  If Random(10) > Random(10)
    cubes()\matrix << 3
    EndIf
  Next
EndProcedure

;;;;; PLUGIN RANDOM

;;;;; PLUGINS

init()

Procedure item_group(group.i,event.i)
  Define color.i
  If group < 10
    current_group = group
    EndIf
  
  If event = #PB_EventType_LeftDoubleClick And group > 0
    move = #False
    color = ColorRequester()
  If color > -1
    group(group,0) = Red(color)/255
    group(group,1) = Green(color)/255
    group(group,2) = Blue(color)/255
    EndIf
  EndIf
EndProcedure

Procedure item_preview(param.i,event.i)
  If  preview
    preview = #False  
  Else 
    preview = #True   
    EndIf
  EndProcedure
  
 Procedure item_fullscreen(param.i,event.i)
    
    If Not fullscreen
 SetWindowLong_(WindowID(#window), #GWL_STYLE, window_style & ~#WS_MAXIMIZE & ~#WS_MINIMIZE & ~#WS_SYSMENU & ~#WS_THICKFRAME & ~#WS_CAPTION )
  SetWindowState(#window,#PB_Window_Maximize)
 event_size()
 fullscreen = #True
Else
  SetWindowLong_(WindowID(#window), #GWL_STYLE, window_style & ~#WS_MAXIMIZE)
  SetWindowState(#window,#PB_Window_Maximize)
 event_size()
 fullscreen = #False
  EndIf
EndProcedure

Procedure item_new(param.i,event.i)
  event_reset(#True)
EndProcedure

Procedure item_left(param.i,event.i)
 posx-4
EndProcedure

Procedure item_right(param.i,event.i)
 posx+4
EndProcedure

Procedure item_up(param.i,event.i)
 posy-4
EndProcedure

Procedure item_down(param.i,event.i)
 posy+4
EndProcedure

Procedure item_scroll_in(param.i,event.i)
 scroll(0.1,window_width/2,window_height/2)
EndProcedure

Procedure item_scroll_out(param.i,event.i)
  scroll(-0.1,window_width/2,window_height/2)
EndProcedure

Procedure item_hexagon(param.i,event.i)
  ForEach cubes()
    cubes()\sc=1
   cubes()\st = ElapsedMilliseconds()
  Next
EndProcedure

Procedure item_open(param.i,event.i)
Define  Pattern$ = "Hexagon Datei (*.hexagon)"
Define Pattern = 0   
 Define i.i
Define a.i,b.i,cubes
  Define File$ = OpenFileRequester("Bitte Hexagon Datei zum Laden auswählen", "", Pattern$, Pattern)
  If File$
    
   Define file.i = ReadFile(#PB_Any,File$)
    
    If file And ReadFloat(file) = #version
      
        event_reset(#False)

       For a = 0 To ArraySize(group())
        For b = 0 To ArraySize(group(),2)
          group(a,b) = ReadFloat(file)
        Next
      Next
      cubes = ReadInteger(file)
      For i = 0 To  cubes-1
        ReadData(file,AddElement(cubes()),SizeOf(cube))
      Next
      
    EndIf

    CloseFile(file)
    
  EndIf

EndProcedure

Procedure item_save(param.i,event.i)
 Define Pattern$ = "Hexagon Datei (*.hexagon)"
 Define Pattern = 0   
  Define i.i
Define a.i,b.i,cubes
  Define File$ = SaveFileRequester("Bitte Hexagon Datei zum Speichern auswählen", "", Pattern$, Pattern)
  If File$
    Define filename.s = File$
    
    If Not Right(filename,Len(".hexagon")) = ".hexagon"
      filename + ".hexagon"
    EndIf
    
    Define file.i = CreateFile(#PB_Any,filename)
    
    WriteFloat(file,#version)
   
    For a = 0 To ArraySize(group())
      For b = 0 To ArraySize(group(),2)
        WriteFloat(file,group(a,b))
      Next
    Next
    
    cubes = ListSize(cubes())
     WriteInteger(file,cubes)
    ForEach cubes()
      
      WriteData(file,cubes(),SizeOf(cube))
    Next
    
    CloseFile(file)

  EndIf

EndProcedure

Procedure event_reset(first.i)

ClearList(cubes())

preview = #False
scaling = 2
posx = window_width/2
posy = window_height/2
current_group = 0

If first
cube(window_width/2,window_height/2)
EndIf

;;;;; PLUGINS RESET

;;;;; PLUGIN ROTATE RESET
rotate = 0
rotate_move = 0
;;;;; PLUGIN ROTATE

;;;;; PLUGINS

EndProcedure

Procedure scroll(scrole.f,x.f,y.f)
  If scaling + scrole > 0.5
  
  Define  x1.f = x*scaling-posx
  Define y1.f =  y*scaling-posy
 
   scaling + scrole
   
  Define  x2.f = x*scaling-posx
   Define y2.f = y*scaling-posy
    
    posx + x2-x1
    posy + y2-y1
    
  EndIf
EndProcedure

Procedure init()  
  Define gadget.i,a.i,b.i
  
  OpenWindow(#window,0,0,window_width,window_height,#title + " (Build "+#version+")",
             #PB_Window_ScreenCentered | 
             #PB_Window_SystemMenu | 
             #PB_Window_MaximizeGadget | 
             #PB_Window_MinimizeGadget | 
             #PB_Window_SizeGadget | 
             #PB_Window_Maximize)
  AddWindowTimer(#window,#timer,30)
  AddKeyboardShortcut(#window,#PB_Shortcut_F11,#fullscreen)
  window_style = GetWindowLong_(WindowID(#window), #GWL_STYLE)
  
  window_width = WindowWidth(#window)
  window_height = WindowHeight(#window)

  CanvasGadget(#canvas,0,0,window_width,window_height,#PB_Canvas_Keyboard )
  UsePNGImageDecoder()
  LoadFont(#font,"Cambria",10)
  SetGadgetFont(#PB_Default,FontID(#font))
  
  ;;;;; PLUGINS WINDOW
  
  ;;;;PLUGIN BASS
If OpenLibrary(#basslib,"bass.dll") 
  BASS_StreamCreateFile.BASS_StreamCreateFile = GetFunction(#basslib,"BASS_StreamCreateFile")
  BASS_ChannelBytes2Seconds.BASS_ChannelBytes2Seconds = GetFunction(#basslib,"BASS_ChannelBytes2Seconds")
  BASS_ChannelSeconds2Bytes.BASS_ChannelSeconds2Bytes = GetFunction(#basslib,"BASS_ChannelSeconds2Bytes")
  BASS_ChannelSetPosition.BASS_ChannelSetPosition = GetFunction(#basslib,"BASS_ChannelSetPosition")	
  BASS_ChannelSetAttribute.BASS_ChannelSetAttribute = GetFunction(#basslib,"BASS_ChannelSetAttribute")
  CallFunction(#basslib,"BASS_Init",-1,44100,0,0,0)
EndIf

For a = 0 To ArraySize(mixer())-1
  For b = 0 To ArraySize(mixer(),2)-1
      mixer(a,b)\value = -1
    Next
 Next

 plugin_bass_window = OpenWindow(#PB_Any,0,0,405,400,"Plugin BASS",#PB_Window_Tool | #PB_Window_SystemMenu | #PB_Window_Invisible,WindowID(#window))
 
gadget = TextGadget(#PB_Any,10,244,120,20,"Vorlagen")
   SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
   SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
   gadget_mixer_template = ComboBoxGadget(#PB_Any,130,240,265,20)
   ForEach templates()
     AddGadgetItem(gadget_mixer_template,-1,templates()\name)
     Next
     gadget_bass = ImageGadget(#PB_Any,152,280,100,100,ImageID(LoadImage(#PB_Any,GetCurrentDirectory()+"resources\plugin_bass.png")))
 SetWindowColor(plugin_bass_window,RGB(20,20,20))
 
 Dim value.s(4)
 value(0) = "A"
 value(1) = "R"
 value(2) = "G"
 value(3) = "B"
 
 Define y.i
  gadget = TextGadget(#PB_Any,10,14,120,20,"Mixer")
   SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
   SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
 Define panel = PanelGadget(#PB_Any, 10, 40, 385, 190)
 Define name.s
 For a = 0 To 9
   If a = 0
     name = "BG"
   Else
     name = "G"+Str(a)
     EndIf
     gadget = AddGadgetItem (panel, -1, name)
 gadget = ContainerGadget(#PB_Any, 0, 0, GetGadgetAttribute(panel, #PB_Panel_ItemWidth),GetGadgetAttribute(panel, #PB_Panel_ItemHeight))
      SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
    y = 10
    
      gadget = TextGadget(#PB_Any,34,y+4,40,20,"VAL")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget = TextGadget(#PB_Any,84,y+4,40,20,"ADD")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
 gadget =  TextGadget(#PB_Any,134,y+4,40,20,"MUL")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget = TextGadget(#PB_Any,184,y+4,40,20,"START")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget = TextGadget(#PB_Any,234,y+4,40,20,"LEN")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget = TextGadget(#PB_Any,284,y+4,40,20,"DYN")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
 gadget =  TextGadget(#PB_Any,314,y+4,40,20,"MAL")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
   gadget =  TextGadget(#PB_Any,344,y+4,40,20,"ACT")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
 y = 40
   For b = 0 To ArraySize(value())-1
 
 gadget = TextGadget(#PB_Any,10,y+4,20,20,value(b))
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  
  mixer(a,b)\gadget_value = StringGadget(#PB_Any,34,y,40,20,StrF(mixer(a,b)\value))
  mixer(a,b)\gadget_add = StringGadget(#PB_Any,84,y,40,20,StrF(mixer(a,b)\add))
 mixer(a,b)\gadget_mul =  StringGadget(#PB_Any,134,y,40,20,StrF(mixer(a,b)\mul))
  mixer(a,b)\gadget_start = StringGadget(#PB_Any,184,y,40,20,Str(mixer(a,b)\start))
  mixer(a,b)\gadget_len = StringGadget(#PB_Any,234,y,40,20,Str(mixer(a,b)\len))
  mixer(a,b)\gadget_dyn = CheckBoxGadget(#PB_Any,284,y+4,13,13,"")
  If mixer(a,b)\dyn : SetGadgetState(mixer(a,b)\gadget_dyn,#PB_Checkbox_Checked) : EndIf
  mixer(a,b)\gadget_mulall = CheckBoxGadget(#PB_Any,314,y+4,13,13,"")
  If mixer(a,b)\mulall : SetGadgetState(mixer(a,b)\gadget_mulall,#PB_Checkbox_Checked) : EndIf
   mixer(a,b)\gadget_active = CheckBoxGadget(#PB_Any,344,y+4,13,13,"")
   If mixer(a,b)\active : SetGadgetState(mixer(a,b)\gadget_active,#PB_Checkbox_Checked) : EndIf
  y + 30
Next
CloseGadgetList()
Next
 
AddElement(item())
item()\func = @item_plugin_bass()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\plugin_bass.png");
item()\window = plugin_bass_window
;;;;PLUGIN BASS
  
;;;;PLUGIN ROTATE
  plugin_rotate_window = OpenWindow(#PB_Any,0,0,200,200,"Plugin Rotate",#PB_Window_Tool | #PB_Window_SystemMenu | #PB_Window_Invisible,WindowID(#window))
  gadget = TextGadget(#PB_Any,10,14,120,20,"Geschwindigkeit")
   SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
   SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget_rotate_speed = StringGadget(#PB_Any,130,10,60,20,StrF(rotate_speed,2))
  gadget = TextGadget(#PB_Any,10,44,120,20,"Startskalierung")
   SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
   SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget_rotate_start = StringGadget(#PB_Any,130,40,60,20,StrF(rotate_start,2))
 gadget_rotate = ImageGadget(#PB_Any,50,80,100,100,ImageID(LoadImage(#PB_Any,GetCurrentDirectory()+"resources\plugin_rotate.png")))
 SetWindowColor(plugin_rotate_window,RGB(20,20,20))
 
AddElement(item())
item()\func = @item_plugin_rotate()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\plugin_rotate.png");
item()\window = plugin_rotate_window
;;;;PLUGIN ROTATE

  ;;;;; PLUGIN RANDOM
  plugin_random_window = OpenWindow(#PB_Any,0,0,200,200,"Plugin Random",#PB_Window_Tool | #PB_Window_SystemMenu | #PB_Window_Invisible,WindowID(#window))
  gadget = TextGadget(#PB_Any,10,14,120,20,"Würfel")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
  SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget_max_cubes = StringGadget(#PB_Any,130,10,60,20,Str(max_cubes))
  gadget = TextGadget(#PB_Any,10,44,120,20,"Schleifendurchgänge")
  SetGadgetColor(gadget,#PB_Gadget_BackColor ,RGB(20,20,20))
   SetGadgetColor(gadget,#PB_Gadget_FrontColor ,#White)
  gadget_loops = StringGadget(#PB_Any,130,40,60,20,Str(loops))
  gadget_random = ImageGadget(#PB_Any,50,80,100,100,ImageID(LoadImage(#PB_Any,GetCurrentDirectory()+"resources\plugin_random.png")))
  SetWindowColor(plugin_random_window,RGB(20,20,20))
  
  AddElement(item())
item()\func = @item_plugin_random()
item()\image = cairo_image_surface_create_from_png (GetCurrentDirectory()+"resources\plugin_random.png");
item()\window = plugin_random_window
;;;;; PLUGIN RANDOM

  ;;;;;; PLUGINS
  
  su_draw = cairo_image_surface_create(0,window_width,window_height)

  event_reset(#True)
  
  main()
EndProcedure

Procedure main()
  Define find.i, gadget.i, event.i, px.i,py.i,key.i,menu.i,a.i,b.i
  
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_Timer
        Select EventTimer()
          Case #timer
            event_update(#False)
         EndSelect
       Case #PB_Event_CloseWindow
         find = #False
         ForEach item()
           If item()\window <> 0 And GetActiveWindow() = item()\window
             HideWindow(item()\window,#True)
             find = #True
             Break
             EndIf
           Next
           
           If Not find
             Break
             EndIf
      Case #PB_Event_SizeWindow
        event_size()
      Case #PB_Event_Menu
        Select EventMenu()
          Case #fullscreen
            item_fullscreen(0,0)
           EndSelect
      Case #PB_Event_Gadget
        gadget = EventGadget()
       event =  EventType()
       ;;;PLUGINS EVENT
       
      ;;;;PLUGIN BASS
       If GetActiveWindow() = plugin_bass_window
         If gadget = gadget_bass And (event = #PB_EventType_LeftClick)
           item_plugin_bass(0,0)
             Continue
         ElseIf gadget = gadget_mixer_template
           Define text.s  = GetGadgetText(gadget_mixer_template)
           
           ForEach templates()
             If text = templates()\name
               
               For a = 0 To ArraySize(mixer())-1
                 For b = 0 To ArraySize(mixer(),2)-1
                   mixer(a,b)\value = templates()\mixer(a,b)\value
                   mixer(a,b)\add = templates()\mixer(a,b)\add
                   mixer(a,b)\mul = templates()\mixer(a,b)\mul
                   mixer(a,b)\start = templates()\mixer(a,b)\start
                   mixer(a,b)\len = templates()\mixer(a,b)\len
                   mixer(a,b)\dyn = templates()\mixer(a,b)\dyn
                   mixer(a,b)\mulall = templates()\mixer(a,b)\mulall
                   mixer(a,b)\active = templates()\mixer(a,b)\active
                 Next
               Next
               
               For a = 0 To ArraySize(mixer())-1
                 For b = 0 To ArraySize(mixer(),2)-1
                   SetGadgetText(mixer(a,b)\gadget_value,StrF(mixer(a,b)\value))
                   SetGadgetText(mixer(a,b)\gadget_add,StrF(mixer(a,b)\add))
                   SetGadgetText(mixer(a,b)\gadget_mul,StrF(mixer(a,b)\mul))
                   SetGadgetText(mixer(a,b)\gadget_start,Str(mixer(a,b)\start))
                   SetGadgetText(mixer(a,b)\gadget_len,Str(mixer(a,b)\len))
                   If mixer(a,b)\dyn : SetGadgetState(mixer(a,b)\gadget_dyn,#PB_Checkbox_Checked) : Else: SetGadgetState(mixer(a,b)\gadget_dyn,#PB_Checkbox_Unchecked) : EndIf
                   If mixer(a,b)\mulall : SetGadgetState(mixer(a,b)\gadget_mulall,#PB_Checkbox_Checked) : Else: SetGadgetState(mixer(a,b)\gadget_mulall,#PB_Checkbox_Unchecked) : EndIf
                   If mixer(a,b)\active : SetGadgetState(mixer(a,b)\gadget_active,#PB_Checkbox_Checked) : Else: SetGadgetState(mixer(a,b)\gadget_active,#PB_Checkbox_Unchecked) : EndIf
                 Next
                 Next
             
               Break
               EndIf
            Next
           
            Continue
           EndIf
         
          For a = 0 To ArraySize(mixer())-1
            For b = 0 To ArraySize(mixer(),2)-1
              With mixer(a,b)
              Select gadget
                Case \gadget_value               
                  \value = ValF(GetGadgetText(\gadget_value))
                  Case \gadget_add
                  \add = ValF(GetGadgetText(\gadget_add))
                 Case \gadget_mul
                 \mul = ValF(GetGadgetText(\gadget_mul))
                 Case \gadget_start
                   \start = Val(GetGadgetText(\gadget_start))
                   Case \gadget_len
                     \len = Val(GetGadgetText(\gadget_len))
                     If \len > 10
                       \len = 10
                       SetGadgetText(\gadget_len,StrF(\len))
                       EndIf
                   Case \gadget_dyn
                     If GetGadgetState(\gadget_dyn) = #PB_Checkbox_Checked
                      \dyn = #True
                    Else
                      \dyn = #False
                      EndIf
                  Case \gadget_mulall
                    If GetGadgetState(\gadget_mulall) = #PB_Checkbox_Checked
                      \mulall = #True
                    Else
                      \mulall = #False
                    EndIf
                      Case \gadget_active
                    If GetGadgetState(\gadget_active) = #PB_Checkbox_Checked
                      \active = #True
                    Else
                      \active = #False
                      EndIf
                  EndSelect
                Next
                EndWith
            Next
        EndIf
        ;;;;PLUGIN BASS
        
       ;;;;PLUGIN RANDOM
        If GetActiveWindow() = plugin_random_window
          If gadget = gadget_random And (event = #PB_EventType_LeftClick Or event = #PB_EventType_LeftDoubleClick)
           item_plugin_random(0,event)
             Continue
         EndIf
        Select gadget
          Case gadget_loops
            loops = Val(GetGadgetText(gadget_loops))
          Case gadget_max_cubes
            max_cubes = Val(GetGadgetText(gadget_max_cubes))
        EndSelect
        EndIf
            ;;;;PLUGIN RANDOM
            ;;;;PLUGIN ROTATE
        If GetActiveWindow() = plugin_rotate_window
             If gadget = gadget_rotate And (event = #PB_EventType_LeftClick)
           item_plugin_rotate(0,0)
             Continue
         EndIf
        Select gadget
          Case gadget_rotate_speed
            rotate_speed = ValF(GetGadgetText(gadget_rotate_speed))
          Case gadget_rotate_start
            rotate_start = ValF(GetGadgetText(gadget_rotate_start))
        EndSelect
        EndIf
            ;;;;PLUGIN RANDOM  
            ;;; PLUGINS
          Select gadget
            Case #canvas
               event.i = EventType()
               px.i = GetGadgetAttribute(#canvas,#PB_Canvas_MouseX)
               py.i = GetGadgetAttribute(#canvas,#PB_Canvas_MouseY)
               key.i = GetGadgetAttribute(#canvas,#PB_Canvas_Key)
              
               menu.i = event_menu(event,px,py)
              If Not menu
               event_active(event,px,py)
              event_move(event,px,py,key.i)
              event_click(event,px,py)
              event_scroll(event)
              EndIf
              
              ;;;PLUGINS EVENT
               ;;;;PLUGIN BASS
              If *stream <> 0 And event = #PB_EventType_KeyDown And key = #PB_Shortcut_Space
                If CallFunction(#basslib,"BASS_ChannelIsActive",*stream) = 1
                  CallFunction(#basslib,"BASS_ChannelPause",*stream)
                  group_reload()
                 Else
                   CallFunction(#basslib,"BASS_ChannelPlay",*stream,0)
                   group_save()
                  EndIf   
                EndIf
                ;;;;PLUGIN BASS
                
              ;;;;PLUGIN ROTATE
                If preview And event = #PB_EventType_KeyDown And key = #PB_Shortcut_Space
                   rotate_move = -((#PI*2)/360)
                  EndIf
              ;;;;PLUGIN ROTATE
              
              ;;; PLUGINS
              EndSelect
    EndSelect
  ForEver
  
  close()
EndProcedure

Procedure event_active(event.i,px.f,py.f)
 If event = #PB_EventType_MouseMove
               Define x.f = px/scaling+posx/scaling   
              Define  y.f = py/scaling+posy/scaling
 
               ForEach cubes()
                 With cubes()
                   If pos(x-\x,y-\y,cube_s)
                     \active = #True
                   Else
                    \active = #False 
                    
                   EndIf
                 EndWith
               Next
             EndIf
             EndProcedure

Procedure event_menu(event.i,px.i,py.i)
  If event = #PB_EventType_MouseMove
    
    If preview
      If py <= (#menu_button_size+#menu_button_margin)*3
       
        menu_show =#True
      Else
       
        menu_show =#False

      EndIf
    Else
      menu_show = #True
    EndIf
              EndIf
    If menu_show And (event = #PB_EventType_LeftClick Or event = #PB_EventType_LeftDoubleClick Or event = #PB_EventType_RightClick Or event = #PB_EventType_MiddleButtonDown)
      
        Define x.f = #menu_button_margin,y.f = #menu_button_margin
      
       ForEach item()
 If (x + #menu_button_size+#menu_button_margin) >= window_width
   x = #menu_button_margin
   y + (#menu_button_size+#menu_button_margin)+8
 EndIf
 
         If px >= x And 
            px <= x+(#menu_button_size-#menu_button_margin) And 
            py >= y And py <= y+(#menu_button_size+#menu_button_margin) 

           If event = #PB_EventType_RightClick
             If item()\window <> 0
               If IsWindowVisible_(WindowID(item()\window)) 
                 HideWindow(item()\window,#True)
               Else              
                  HideWindow(item()\window,#False)
                 EndIf
              EndIf
             Else
          If  item()\func <> 0         
            CallFunctionFast(item()\func,item()\param,event)      
          EndIf
          EndIf
          ProcedureReturn #True
           Break
         EndIf
         
         x + (#menu_button_size+#menu_button_margin)

       Next
   
     EndIf
     
     ProcedureReturn #False
EndProcedure

Procedure close()
  CloseWindow(#window)
EndProcedure

Procedure event_update(export.i)
  ;;;; PLUGINS UPDATE
  
  ;;;; PLUGIN BASS  
  If Not export
  Define visual_value.f,byte_value.f,newvalue.f
   Define i.i,a.i,b.i
  If *stream <> 0 And CallFunction(#basslib,"BASS_ChannelIsActive",*stream) = 1
    CallFunction(#basslib,"BASS_ChannelGetData",*stream,*byte_buffer,$80000002)
      For i = 0 To MemorySize(*visual_buffer)-1 Step 4
        
    	  visual_value = PeekF(*visual_buffer+i)
    		byte_value = PeekF(*byte_buffer+i)
    		
    		If byte_value > visual_value
    			newvalue = byte_value
    		Else
    			newvalue = visual_value - visual_value/10
    		EndIf
    		
    		PokeF(*visual_buffer+i,newvalue)
    	Next
    	
    	Define group.i, color.i
    	
    	Define arrsize.i = ArraySize(group())
    	
    	Define mulall = avg(0,1,1)
    	For a = 0 To ArraySize(mixer())-1
    	   If a = 0
    	      group = 10
    	    Else
    	      group = a
    	    EndIf
    	    
    	    For b = 0 To ArraySize(mixer(),2)-1
    	   If b = 0
    	      color = 3
    	    Else
    	      color = b-1
    	    EndIf 
    	    With mixer(a,b)
    	      
    	      If \active
    	    If \value >= 0
    	      group(group,color) = \value
    	    Else
    	      group(group,color) = group_cache(group,color)
    	    EndIf
    	     
    	     group(group,color) + \add
 
    	     If \dyn And \len > 0
    	       If \start+\len<= arrsize
    	         group(group,color) * avg(\start,\len,arrsize)
    	         EndIf
    	  EndIf
    	  
    	  If \mul > 0
    	  group(group,color) * \mul
    	EndIf
    	
    	If \mulall
    	  group(group,color) * (1+mulall)
    	EndIf
    Else
      group(group,color) = 0
    	EndIf
    	      EndWith
    	  Next
    	Next
  EndIf 	
  ;;;; PLUGIN BASS
  
  ;;;; PLUGINS
	
  If move_horizontal <> 0
    posx+move_horizontal  
  EndIf 
  
  If move_vertical <> 0
   posy+move_vertical
 EndIf

  Define dc = StartDrawing(CanvasOutput(#canvas))
  Define su = cairo_win32_surface_create(dc)
  
  Define cr = cairo_create(su)
  cairo_rectangle(cr,0,0,OutputWidth(),OutputHeight())
   cairo_set_source_rgb(cr,0,0,0)
   cairo_paint(cr)
   cairo_destroy(cr)
   EndIf
  cr = cairo_create(su_draw)
  cairo_rectangle(cr,0,0,window_width,window_height)
   cairo_set_source_rgb(cr,0,0,0)
   cairo_paint(cr)
   
  cairo_rectangle(cr,0,0,window_width,window_height)
     cairo_set_source_rgba(cr, group(10,0),group(10,1),group(10,2),group(10,3))
     cairo_paint(cr)
     
     cairo_destroy(cr)
     
  ForEach cubes()
    With cubes()
      If \matrix <> 0
        draw_hexagon(\x*scaling-posx,\y*scaling-posy,\sc*scaling,su_draw,cubes())
      EndIf
   If Not export
      If Not preview
      
      cr = cairo_create(su_draw)
  
      cairo_set_line_width(cr,2)
      cairo_set_source_rgba(cr,1.0,1.0,1.0,1.0)
      cairo_arc(cr,\x*scaling-posx,\y*scaling-posy,#button_radius,0,#PI*2)
      
      cairo_stroke(cr)

    If \active
      
       cairo_set_source_rgba(cr,1,1,1,1.0)
cairo_new_path(cr)
  
      cairo_arc(cr,(\x)*scaling-posx,(\y+cube_s/2)*scaling-posy,#button_radius,0,#PI*2)
      	cairo_stroke(cr)
     cairo_new_path(cr)
     cairo_arc(cr,(\x-cube_r/2)*scaling-posx,(\y-cube_s/4)*scaling-posy,#button_radius,0,#PI*2)
     	cairo_stroke(cr)
      cairo_new_path(cr)
      cairo_arc(cr,(\x+cube_r/2)*scaling-posx,(\y-cube_s/4)*scaling-posy,#button_radius,0,#PI*2)
      	cairo_stroke(cr)
      cairo_new_path(cr)
      cairo_arc(cr,(\x+cube_r/2)*scaling-posx,(\y+cube_s/4)*scaling-posy,#button_radius,0,#PI*2)
      	cairo_stroke(cr)
           cairo_new_path(cr)
           cairo_arc(cr,(\x-cube_r/2)*scaling-posx,(\y+cube_s/4)*scaling-posy,#button_radius,0,#PI*2)
           	cairo_stroke(cr)
             cairo_new_path(cr)
             cairo_arc(cr,(\x)*scaling-posx,(\y-cube_s/2)*scaling-posy,#button_radius,0,#PI*2)
             	cairo_stroke(cr)
				  cairo_close_path(cr)
				  cairo_stroke(cr)
				  
				EndIf
				cairo_destroy(cr)
        EndIf
      If \sc < \s
        \sc + (ElapsedMilliseconds() - \st) /3
        \st = ElapsedMilliseconds()
        
        If \sc >= \s
           \sc = \s
         EndIf
       EndIf
       EndIf
     EndWith
   Next
   
   If Not export
   cr = cairo_create(su)

      cairo_translate(cr,window_width/2,window_height/2)
      
      ;;;; PLUGINGS UPDATE

      ;;;; PLUGIN ROTATE
   
      If rotate_move > 0
      rotate + rotate_move
    ElseIf rotate_move < 0
       rotate + rotate_move
      rotate_move+rotate_move
       If rotate <= 0
         rotate_move = 0
         rotate = 0
         EndIf
       EndIf
       
       If rotate > 0
         rotate_scaling = (rotate/10)+rotate_start
         cairo_rotate(cr,rotate)
           cairo_scale(cr,rotate_scaling,rotate_scaling)
    
          EndIf       
          ;;;;PLUGIN ROTATE
          
          ;;;;PLUGINS
     
      cairo_translate(cr,-window_width/2,-window_height/2)
    
      cairo_set_source_surface(cr,su_draw,0,0)
      cairo_paint(cr)
      cairo_destroy(cr)
       If Not menu_show And menu_opacity > 0
         menu_opacity -0.03
         ElseIf menu_show And menu_opacity < 1
           menu_opacity = 1
        EndIf
        
      If menu_show Or menu_opacity > 0
       
        Define w,h,scale.f,margin,x.f = #menu_button_margin,y.f = #menu_button_margin+margin
        
   ForEach item()
        
     If item()\image <> 0
           cr = cairo_create(su)
 w= cairo_image_surface_get_width (item()\image);
 h = cairo_image_surface_get_height (item()\image);

 scale = #menu_button_size/w*menu_opacity
 margin = 0
 
 If (item()\func = @item_group() And current_group = item()\param) Or 
    (item()\func = @item_preview() And Not preview) Or 
     (item()\func = @item_fullscreen() And fullscreen) Or 
    (item()\func = @item_right() And move_horizontal > 0) Or
    (item()\func = @item_left() And move_horizontal < 0) Or 
    (item()\func = @item_up() And move_vertical < 0) Or
    (item()\func = @item_down() And move_vertical > 0)
 margin = 12
EndIf 
 cairo_scale (cr,scale, scale)

 If (x + #menu_button_size+#menu_button_margin+#menu_button_size)*scale >= window_width
   x = #menu_button_margin
   y + (#menu_button_size+#menu_button_margin)/scale+8
   EndIf
 
cairo_set_source_surface (cr,item()\image, x, y+margin)
cairo_paint (cr) 

If item()\func = @item_group() And item()\param > 0
  
      cairo_set_source_rgb(cr,group(item()\param,0),group(item()\param,1),group(item()\param,2))
    cairo_arc(cr,x+#menu_button_size,#menu_button_size+y+margin ,#menu_button_size/2,0,#PI*2)
    cairo_fill(cr)
  
  EndIf
          EndIf
          x + (#menu_button_size+#menu_button_margin)/scale*menu_opacity
           cairo_destroy(cr)
        Next
        EndIf
        cairo_surface_destroy(su)
        StopDrawing()
        EndIf
EndProcedure

Procedure event_size()
  posx+(window_width-WindowWidth(#window))/2
  posy+(window_height-WindowHeight(#window))/2
  
  ResizeGadget(#canvas,0,0,WindowWidth(#window),WindowHeight(#window))
  
  window_width = WindowWidth(#window)
  window_height = WindowHeight(#window)
  
  cairo_surface_destroy(su_draw)
   su_draw = cairo_image_surface_create(0,window_width,window_height)
EndProcedure

Procedure event_scroll(event)
  If event = #PB_EventType_MouseWheel 
   Define wheel.f = GetGadgetAttribute(#canvas,#PB_Canvas_WheelDelta)/10

    If scaling+wheel >= 0.5 
      
  Define find = #False
      ForEach cubes()
        With cubes()
          If \active
            
            scroll(wheel,\x,\y)

              find = #True
              
              Break
          EndIf
        EndWith
        
      Next
      
      If Not find
            scroll(wheel,GetGadgetAttribute(#canvas,#PB_Canvas_MouseX),GetGadgetAttribute(#canvas,#PB_Canvas_MouseY))
      EndIf
      
    EndIf
  EndIf
EndProcedure

Procedure event_move(event.i,px.i,py.i,key.i)
  Select event
    Case #PB_EventType_LeftButtonDown
      move_x = px
      move_y = py
      
      move = #True
    Case #PB_EventType_LeftButtonUp
      move = #False
    Case #PB_EventType_MouseMove
      If move
        posx + (move_x-px)
        posy + (move_y-py)
       
        move_x = px
        move_y = py
      EndIf
     
    Case #PB_EventType_KeyDown
     
      Select key
          Case #PB_Shortcut_Right
            move_horizontal = 5
          Case #PB_Shortcut_Left
            move_horizontal = -5
          Case #PB_Shortcut_Up
            move_vertical = -5
          Case #PB_Shortcut_Down
            move_vertical = 5
        
   Case #PB_Shortcut_0
            current_group = 0       
          Case #PB_Shortcut_1
            current_group = 1         
          Case #PB_Shortcut_2
            current_group = 2
          Case #PB_Shortcut_3
            current_group = 3
          Case #PB_Shortcut_4
            current_group = 4
           Case #PB_Shortcut_5
             current_group = 5
            Case #PB_Shortcut_6
              current_group = 6
             Case #PB_Shortcut_7
               current_group = 7
              Case #PB_Shortcut_8
                current_group = 8
               Case #PB_Shortcut_9
            current_group = 9
      EndSelect
    Case #PB_EventType_KeyUp
      Select key
          Case #PB_Shortcut_Right
            move_horizontal = 0
          Case #PB_Shortcut_Left
            move_horizontal = 0
          Case #PB_Shortcut_Up
            move_vertical = 0
          Case #PB_Shortcut_Down
            move_vertical = 0
  
          Case #PB_Shortcut_Space
            If preview
               preview = #False
              Else 
           preview = #True
         EndIf
      EndSelect
  EndSelect
EndProcedure

Procedure pos(x.f,y.f,rad.f)
  If Pow(x,2) + Pow(y,2) < Pow(rad,2)
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure event_click(event.i,px.i,py.i)
      Define examine.i,x.f,y.f
  Select event     
    Case #PB_EventType_LeftClick
       x = px+posx   
     y = py+posy
 
      x/scaling
      y/scaling
      
      ForEach cubes() 
       examine = 0
        px = cubes()\x
        py = cubes()\y

         With cubes()
           
           If \active
             If pos(x-\x,y-\y+cube_s/2,#button_radius*2)
               If current_group = 0
                 \matrix ! %1
               EndIf
               
              \group[5] = current_group
               Break
             ElseIf pos(x-\x-cube_r/2,y-\y-cube_s/4,#button_radius*2)
               If current_group = 0
                 \matrix ! %100
               
                EndIf
                
                \group[3] = current_group
               Break
             ElseIf pos(x-\x+cube_r/2,y-\y-cube_s/4,#button_radius*2)
               If current_group = 0
                  \matrix ! %10
                
                 EndIf
               
             \group[4] = current_group
               Break
             ElseIf pos(x-\x+cube_r/2,y-\y+cube_s/4,#button_radius*2)
               If current_group = 0
                   \matrix ! %10000
                
                EndIf
               
               \group[1] = current_group
               Break
             ElseIf pos(x-\x-cube_r/2,y-\y+cube_s/4,#button_radius*2)
               If current_group = 0
                  \matrix ! %1000
                 
                   EndIf
                \group[2] = current_group
           
               Break
             ElseIf pos(x-\x,y-\y-cube_s/2,#button_radius*2)
               If current_group = 0
                 \matrix ! %100000
                 
                EndIf
                 
                \group[0] = current_group
               Break
             EndIf
           EndIf
         EndWith
                
        If pos(x-px,y-py,#button_radius*2)     
          
          With cubes()

            If \matrix = 0
             
              \matrix = %000111
              \sc=1
              \st = ElapsedMilliseconds()
            Else          
              \matrix = 0
            EndIf
            
            If \examine = 0
              examine = 1
             
              \examine = 1
            EndIf    
           
          EndWith      
                 
          If examine = 1
              cube(px+cube_r*2,py)
            	cube(px-cube_r*2,py)
            
            	cube(px+cube_r,py-cube_s-cube_h)
            	cube(px-cube_r,py-cube_s-cube_h)
            
            	cube(px+cube_r,py+cube_s+cube_h)
            	cube(px-cube_r,py+cube_s+cube_h)    	
          	EndIf
   
          Break
          
         EndIf 
     
      Next
  EndSelect
EndProcedure

Procedure cube(x.f,y.f)	
  ForEach cubes()
    With cubes()
      If Int(\x) = Int(x) And Int(\y) = Int(y)
        ProcedureReturn
      EndIf
    EndWith
	Next
		
  AddElement(cubes())
  
  With cubes()
    \x = x
    \y = y
    \s = cube_s
    \sc = 1
    \st = ElapsedMilliseconds()
    \matrix = 0
    \examine = 0
  EndWith
  
EndProcedure

Procedure draw_hexagon(x.f,y.f,s.f,su.i,*this.cube)
  
  Define matrix = *this\matrix

  Define h.f = Round(Sin(Radian(30))*s,#PB_Round_Nearest)
  Define r.f = Round(Cos(Radian(30))*s,#PB_Round_Nearest)
  Define b.f = s+2*h
  Define a.f = 2*r
  
  Define cr = cairo_create(su)
  
  cairo_set_line_width(cr,2)
  
  If matrix & %100000

	cairo_move_to(cr,x,y)
	cairo_line_to(cr,x+r,y+s/2)
	cairo_line_to(cr,x,y+b/2)
 	cairo_line_to(cr,x-r,y+s/2)
 	cairo_close_path (cr)
 	 	If *this\group[0] > 0
 cairo_set_source_rgba(cr, group(*this\group[0],0),group(*this\group[0],1),group(*this\group[0],2),group(*this\group[0],3));
 cairo_fill_preserve (cr)
 EndIf
 
 	cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 	cairo_stroke(cr)	

 	EndIf
  
    If matrix & %10000
	cairo_move_to(cr,x,y-b/2)
	cairo_line_to(cr,x,y)
	cairo_line_to(cr,x-r,y+s/2)
 	cairo_line_to(cr,x-r,y-s/2)
 	cairo_close_path (cr)
 	 	If *this\group[1] > 0
 	 
 cairo_set_source_rgba (cr, group(*this\group[1],0),group(*this\group[1],1),group(*this\group[1],2),group(*this\group[1],3));
 cairo_fill_preserve (cr)
 EndIf
 
 	cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 	cairo_stroke(cr)
 	
 EndIf
 
    If matrix & %1000
	cairo_move_to(cr,x,y-b/2)
	cairo_line_to(cr,x,y)
	cairo_line_to(cr,x+r,y+s/2)
 	cairo_line_to(cr,x+r,y-s/2)
 	cairo_close_path (cr)
 	 	If *this\group[2] > 0
 	 
 cairo_set_source_rgba(cr, group(*this\group[2],0),group(*this\group[2],1),group(*this\group[2],2),group(*this\group[2],3));
 cairo_fill_preserve (cr)
 EndIf
 
 	cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 	cairo_stroke(cr) 	
 	
 EndIf
 
    If matrix & %100
	cairo_move_to(cr,x,y)
	cairo_line_to(cr,x,y+b/2)
	cairo_line_to(cr,x+r,y+s/2)
 	cairo_line_to(cr,x+r,y-s/2)
 	cairo_close_path (cr)
 	 	If *this\group[3] > 0
 	 
 cairo_set_source_rgba(cr, group(*this\group[3],0),group(*this\group[3],1),group(*this\group[3],2),group(*this\group[3],3));
 cairo_fill_preserve (cr)
 EndIf
 
 	cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 	cairo_stroke(cr) 	
 EndIf
 
    If matrix & %10
	cairo_move_to(cr,x,y)
	cairo_line_to(cr,x,y+b/2)
	cairo_line_to(cr,x-r,y+s/2)
 	cairo_line_to(cr,x-r,y-s/2)
 	cairo_close_path (cr)
 	 	If *this\group[4] > 0
 cairo_set_source_rgba(cr, group(*this\group[4],0),group(*this\group[4],1),group(*this\group[4],2),group(*this\group[4],3));
 cairo_fill_preserve (cr)
 EndIf
 
 	cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 	cairo_stroke(cr)	
 		EndIf

    If matrix & %1
	cairo_move_to(cr,x,y)
	cairo_line_to(cr,x+r,y-s/2)
	cairo_line_to(cr,x,y-b/2)
 	cairo_line_to(cr,x-r,y-s/2)
 	cairo_close_path (cr)
 	
 	If *this\group[5] > 0
 	  cairo_set_source_rgba(cr, group(*this\group[5],0),group(*this\group[5],1),group(*this\group[5],2),group(*this\group[5],3));
 cairo_fill_preserve (cr)
 EndIf

 cairo_set_source_rgba(cr,0.6,0.6,0.6,1)
 
cairo_stroke(cr);

EndIf
cairo_destroy(cr)
EndProcedure
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 276
; FirstLine = 231
; Folding = ------
; EnableXP
; UseIcon = symbol.ico
; Executable = Hexagon.exe